use tokio::time;

async fn print_message_async(second_count : u64, message : &str)
{
    time::sleep(time::Duration::from_secs(second_count)).await;

    println!("{} : {}", second_count, message);
}

#[tokio::main]
async fn main()
{
    tokio::spawn(print_message_async(3, "메시지 #1"));
    tokio::spawn(print_message_async(2, "메시지 #2"));
    tokio::spawn(print_message_async(1, "메시지 #3"));

    time::sleep(time::Duration::from_secs(4)).await;

    println!("------------");

    tokio::join!
    (
        print_message_async(2, "메시지 #4"),
        print_message_async(3, "메시지 #5"),
        print_message_async(1, "메시지 #6")
    );
}